import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

public class UdpControl {
	public static void main(String[] args) throws IOException {
		String temp;
		InetAddress remoteIp;
		int remotePort;
		
		BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
		
		System.out.println("  Ethernet UDP Demonstration");
		System.out.println("------------------------------\n");
	
		// Read necessary parameters - destination IP and port
		System.out.print("Enter remote IP to sent to: ");
		temp = r.readLine();
		remoteIp = InetAddress.getByName(temp);
		
		System.out.print("Enter remote port to send to: ");
		temp = r.readLine();
		remotePort = Integer.parseInt(temp);

		System.out.println("Entering control loop - enter port -1 to quit\n");

		DatagramSocket socket = new DatagramSocket();
		
		// Main loop - get a port number and 0 for OFF, 1 for ON
		while(true) {
			int portNum, task;
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			System.out.print("               Enter port: ");
			try {
				portNum = Integer.parseInt(r.readLine()); 
			} catch (NumberFormatException e) {
				System.out.println("Invalid entry");
				continue;
			}
			
			if (portNum == -1) break;
			
			System.out.print("Enter state (0-off, 1-on): ");

			try {
				task = Integer.parseInt(r.readLine()); 
			} catch (NumberFormatException e) {
				System.out.println("Invalid entry");
				continue;
			}
			
			// Prepare bytes of 4byte integers for packet
			bos.write(portNum >> 24);
			bos.write(portNum >> 16);
			bos.write(portNum >> 8);
			bos.write(portNum);
			bos.write(task >> 24);
			bos.write(task >> 16);
			bos.write(task >> 8);
			bos.write(task);
			
			// Send packet
			DatagramPacket packetout = new DatagramPacket(bos.toByteArray(), bos.size(), remoteIp, remotePort);
			socket.send(packetout);
			
			// Get response
			byte[] rcvdData = new byte[1024];
			DatagramPacket rcvdPacket = new DatagramPacket(rcvdData, rcvdData.length);
			socket.receive(rcvdPacket);
			
			// Print response from device
			System.out.println("Received: " + new String(rcvdData, 0, rcvdPacket.getLength() - 1));
		}
		
		socket.close();
	}
}
